//
//  ViewController.m
//  GridRollYourOwnData_ObjC
//
//  Created by Torrey Betts on 8/26/15.
//  Copyright (c) 2015 Infragistics. All rights reserved.
//

#import <IG/IG.h>
#import "ViewController.h"
#import "igSalesmanItem.h"

@interface ViewController () <IGGridViewDataSource>
{
    IGGridView *_gridView;
    NSArray *_data;
    id<IGGridViewThemeDefinition> _theme;
}
@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];

    self.view.backgroundColor = [UIColor whiteColor];

    _data = [igSalesmanItem generateData:100];

    _gridView = [[IGGridView alloc]initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height) style:IGGridViewStyleDefault];
    _gridView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;

    [_gridView registerClass:[IGGridViewCell class] forCellReuseIdentifier:@"CELL"];

    if ([UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPhone)
        _gridView.columnWidth = [[IGColumnWidth alloc]initWithWidth:150];

    _gridView.theme = _theme = [[IGGridViewLightTheme alloc]init];

    [self.view addSubview:_gridView];

    _gridView.dataSource = self;
}

-(NSInteger)gridView:(IGGridView *)gridView numberOfRowsInSection:(NSInteger)section
{
    return _data.count;
}

-(NSInteger)numberOfColumnsInGridView:(IGGridView *)gridView
{
    return 4;
}

-(IGGridViewCell *)gridView:(IGGridView *)gridView cellAt:(IGCellPath *)path
{
    IGGridViewCell* cell = [gridView dequeueReusableCellWithIdentifier:@"CELL"];

    igSalesmanItem* item = _data[path.rowIndex];

    switch (path.columnIndex) {
        case 0:
            cell.textLabel.text = item.firstName;
            break;
        case 1:
            cell.textLabel.text = item.lastName;
            break;
        case 2:
            cell.textLabel.text = item.territory;
            break;
        case 3:
            cell.textLabel.text = [NSString stringWithFormat:@"%ld", (long)item.yearToDateSales];
            break;
        default:
            break;
    }

    return cell;
}

-(NSString *)gridView:(IGGridView *)gridView titleForHeaderInColumn:(NSInteger)column
{
    NSString* title = nil;
    switch (column)
    {
        case 0:
            title = @"firstName";
            break;
        case 1:
            title = @"lastName";
            break;
        case 2:
            title = @"territory";
            break;
        case 3:
            title = @"yearToDateSales";
            break;
        default:
            break;
    }
    return title;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (BOOL)prefersStatusBarHidden
{
    return YES;
}

@end